<?php
/*
Aplomb Poll - Version 1.1
Copyright (C) 2003 Aplomb Scripts
http://www.global-centre.com/aplomb/

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

class AdminToolTip extends HTML {

function Execute() {
	echo '<tr><td class="content" valign="top"><div align="center"><table class="tooltip" width="500"><tr><td>';
	switch ($_GET['tip']) {
		case 'manage':
			echo '<b>Manage Polls</b><br />Manage existing polls, and add new ones. The "Create New Poll" allows you to create a new poll. You can also edit existing polls. The "View/Edit" page will allow you to edit poll answers, the poll question, and number of votes. "Lock/Unlock" will allow to to select whether users can vote in a poll. Finally, "Delete" will remove the poll, and all it\'s data. Make sure you actually want to delete this poll before doing so.';
		break;
		case 'genhtml':
			echo '<b>Generate HTML</b><br />Generate the HTML code to add the poll to your site. Just select a poll from the drop-down menu, and click on Generate. The HTML code will then be generated. This HTML is XHTML-compliment.';
		break;
		case 'options':
			echo '<b>Options</b><br />Edit various script settings, and the password to the Admin CP. From this page, you can edit the Site URL, Poll Script URL, and password. All of the options here are identical to those in config.php. When you update the options, config.php will be automatically updated with the new settings.';
		break;
		case 'tools':
			echo '<b>Tools</b><br />Includes various tools for use with Aplomb Poll. Mass Poll Lock does exactly what it says - locks all of the polls. Mass Poll Unlock is just the opposite, and unlocks all polls. Reset Poll Votes will reset all the votes, but will not delete the polls. This means all polls go back to 0 votes. Delete all will allow you to remove ALL polls. If you use this, all existing polls will be removed, and will not be recoverable. Unless, you\'ve remember to back up your data of course. The Backup tool will create a backup of poll data, and it\'s accompanying tool, Restore Backup will restore it. The file checker will check all required files are in place, and the extension checker will check for what php extensions are installed.';
		break;
		case 'logout':
			echo '<b>Logout</b><br />This logs you out from the Aplomb Poll admin control panel, and re-directs you to your website. Next time, you attempt to access the admin control panel you will be asked for your password again. Logging out will prevent your control panel from unauthorized access.';
		break;
		case 'siteurl':
			echo '<b>Site URL</b><br />Aplomb Poll uses your Site URL throughout the script in various places. For example, when you log out, from the script, you will be re-directed to your main site. It is also used on error pages, and will be shown as a link on the voting page.';
		break;
		case 'pollurl':
			echo '<b>Poll Script URL</b><br />The web accessible URL which the poll script is stored in. This should look something like http://www.yoursite.com/poll. Do not specify a file name afterwards.<br /><br />Try using <b>http://'.$_SERVER['HTTP_HOST'].preg_replace("'/admin.php'si", "", $_SERVER['PHP_SELF']).'</b> if unsure.<br /><br />Do not include a trailing slash.';
		break;
		case 'acppassword':
			echo '<b>Change Admin CP Password</b><br />This changes the password you use to access the Aplomb Poll 1.1 Administration Center.<br /><br /><b>Old Password:</b> Required for security reasons. Enter the current ACP password.<br /><br /><b>New Password:</b> Enter the new ACP password.<br /><br /><b>Confirm New Password:</b> Re-enter the new password, to make sure you typed it in correctly.';
		break;
		case 'masslock':
			echo '<b>Mass Poll Lock</b><br />This tool will attempt to lock/close all polls. When a poll is locked, no new votes will be accepted.<br /><br />Mass Poll Unlock will do the opposite of this tool.';
		break;
		case 'massunlock':
			echo '<b>Mass Poll Unlock</b><br />This tool will attempt to unlock/open all polls. When a poll is opened, new votes will be accepted.<br /><br />Mass Poll Lock will do the opposite of this tool.';
		break;
		case 'resetvotes':
			echo '<b>Reset Poll Votes</b><br />This tool will attempt to reset the votes of all polls. Questions, Locked/Unlock Status, and Answers will remain the same, but the amount of votes in every poll will be reset to 0, along with the amount of votes for each poll answer.';
		break;
		case 'deleteall':
			echo '<b>Delete All Polls</b><br />This tool will attempt to delete all polls which currently exist. Make sure you are sure you wish to remove all polls, as this tool will delete all poll information, including questions, answers, and amount of votes. After deleting, there is no way of recovering the poll information, unless you have made a backup. If you simply wish to stop users from voting, use the Mass Poll Lock tool.';
		break;
		case 'backup':
			echo '<b>Backup Poll Data</b><br />This tool will backup all the data from the poll data folder (db) into a backup directory, which can be restored at a later point. This is useful for times when certain files get corrupted losing your data, or when you decide to upgrade Aplomb Poll to a later version.<br /><br /><strong>Backup Name:</strong> The name of your backup. For example you could name your backup <i>Server Upgrade Jan 2002</i>.<br /><strong>Compress Poll Data:</strong> This option is only avaliable to users with the ZLib Extension installed. It will compress the data before saving it, causing less server space to be used. The ZLib extension is required to restore compressed backup files.<br /><br />To find out whether the ZLib extension is installed, go to the Extension Checker.';
		break;
		case 'restore':
			echo '<b>Restore Poll Data</b><br />This tool will allow you to restore backups of files which were earlier created with the Backup facility. To select a backup to restore, simply click on Restore Backup next to it. On the next screen, you will be asked for which polls you wish to restore, and what you want to do if the poll already exists.<br /><br />To start the restore, just click on Restore Files, and the script will do the rest.';
		break;
		case 'filechecker':
			echo '<b>File Checker</b><br />This tool checks all required files exist, and that they are all CHMOD-ed correctly. If a file/directory does not exist, simply upload a copy of it from the Aplomb Poll distribution package. If a file  is not writable or readable, and it appears in red, this means there is a permissions error which must be corrected. '.$this->ToolTip("chmod");
		break;
		case 'extensionchecker':
			echo '<b>Extension Checker</b><br />This tool detects whether extension librarys which Aplomb Poll can use are installed. All of these are optional. However, if they are installed, you will have extra features.';
		break;
		case 'chmod':
			echo '<b>Permissions error!</b><br />If a box on the File Checker turns Red, Aplomb Poll cannot read/write to this file, and it will need to be changed. Aplomb Poll must be able to read all files listed in the File Checker, and be able to write to config.php, and the db and backup folders. To fix this, you will need to CHMOD files which have permission errors. Try CHMOD-ing to either 666 or 777.';
		break;
		case 'defaultpw':
			echo '<b>Default Password Security Risk</b><br />By default, the password to the admin section of Aplomb Poll will be set as "password". We recommend you do not use the default password, as it is a security risk. The password can be changed in config.php, or through the Options section of the ACP.';
		break;
	}
	echo '<br /><center><a href="javascript:window.close()">Close</a></center></td></tr></table></div>';
}

}
?>